#!/usr/bin/env python3
# -*- coding: utf8 -*-

######################################################################################
# Documentation: http://infohost.nmt.edu/tcc/help/pubs/tkinter/web/ttk-Treeview.html #
######################################################################################

from tkinter import *
from tkinter import ttk

import sqlite3

con = sqlite3.connect('apodixis_test.db')

cur = con.cursor()
cur1 = con.cursor()

qryEpixirisis =  "SELECT afm, eponimia FROM epixirisis"
qryApoodixis = "SELECT ddate, arithmos_apod, poso FROM apodixis WHERE afm=? \
ORDER BY 1, 2"

root = Tk()
pitem = StringVar()

def close_prev(event):
    """ Κλείνει το προηγούμενο δέντρο όταν
ανοίγουμε το επόμενο.
Επίδειξη για το virtual event.
"""
    
    widget = event.widget # Το στοιχείο ελέγχου που δημιούρησε το συμβάν
    item = widget.selection() # Παίρνουμε το όνομα του επιλεγμένου

    pitem = widget.prev(item) # Παίρνουμε το προηγούμενο

    widget.item(pitem, open=FALSE) # και αν είναι ανοικτό το κλείνουμε.
    widget.see(item)

col = ('hmerominia', 'arapod', 'poso') # Ορίζουμε τις στήλες.
heads = ["ΗΜΕΡΟΜΗΝΙΑ", "ΑΡΙΘΜΟΣ ΑΠΟΔΕΙΞΗΣ", "ΠΟΣΟ"] # Ορίζουμε τις κεφαλίδες.

tree = ttk.Treeview(root, columns=col)

tree.heading("#0", text='ΕΠΙΧΕΙΡΗΣΕΙΣ') # Ορίζουμε τη γονική κεφαλίδα.

for c, h in zip(col, heads):
    tree.heading(c, text=h) # Τοποθετούμε τις κεφαλίδες σε αντιστοιχία με τις στήλες.

cur.execute(qryEpixirisis)# Το πρώτο σετ δεδομένων, επιλέγουμε τις επιχειρήσεις.

for row in cur.fetchall():
    tree.insert("", END, row[0], text=row[1])

    cur1.execute(qryApoodixis, (row[0],)) # Επιλέγουμε τις αποδείξεις που αντιστοιχούν στην επιχείρηση. row[0]=ΑΦΜ της επιχείρησης.
    for r in cur1.fetchall():
        tree.insert(row[0], END, text="", values=(r[0], r[1], "{0:.2f}".format(r[2]))) #Εισάγουμε στο treeview τις εγγραφές που αντιστοιχούν στην εκάστοτε επιχείρηση.
    
tree.column('poso', anchor=E) #Στοιχίζουμε δεξιά το αριθμητικό πεδίο.
tree.grid(row=0, column=0, sticky=N+S+E+W)
tree.rowconfigure(0, weight=1)
tree.columnconfigure(0, weight=1)

tree.bind('<<TreeviewOpen>>', close_prev) #Ενεργοποιούμε το συμβάν για άνοιγμα κλείσιμο του δέντρου.

root.rowconfigure(0, weight=1)
root.columnconfigure(0, weight=1)
root.title("Δοκιμή")
mainloop()

cur1.close()
cur.close()
con.close()
